# Dokumetacja API

| Api                                            | Zadania tej klasy                                                |
| ---------------------------------------------- | ---------------------------------------------------------------- |
| [/config](#config)                             | Załadowanie konfiguracji startowej do aplikacji PlanNaPlan       |
| [/getCoursesWithGroups](#getcourseswithgroups) | Zwrócenie wszytskich kursów (ćwiczenia, wykłady) razem z grupami |
| [/getCourseGroups](#getcoursegroups)           | Zwrócenie grup dla danego kursu                                  |
| [/getCourses](#getcourses)                     | Zwróenie wszystkich kursów                                       |

## config

Source code: [link](../restservice/src/main/java/com/plannaplan/controllers/ConfigController.java)

```
POST /config
```

#### Opis

Endpoint konfigurujacy caly system i importujacy dane do bazy.

#### Parametry

| Type | Name                    | Consumes            | Opis                            | Type |
| ---- | ----------------------- | ------------------- | ------------------------------- | ---- |
| Body | **file** </br> required | multipart/form-data | Plik .xlsx z potrzebnymi danymi | file |

## getcourseswithgroups

Source code: [link](../restservice/src/main/java/com/plannaplan/controllers/getCoursesWithGroups.java)

```
GET /getCoursesWithGroups
```

#### Opis

Zwraca wszystkie dostepne kursy wraz z lista grup dla poszczegolnych kursow.

## getcoursegroups

Source code: [link](../restservice/src/main/java/com/plannaplan/controllers/GroupController.java)

```
GET /getCourseGroups
```

#### Opis

Endpoint konfigurujacy caly system i importujacy dane do bazy.

#### Parametry

| Type        | Name                  | Consumes | Opis                                      | Type |
| ----------- | --------------------- | -------- | ----------------------------------------- | ---- |
| Query Param | **id** </br> required | -        | id kursu dla ktorego chcemy zwrocic grupy | int  |
| Query Param | **capacity** </br>    | -        | czy ma zwrocic pole pojemnosci grupy      | bool |

## getcourses

Source code: [link](../restservice/src/main/java/com/plannaplan/controllers/getCoursesWithGroups.java)

```
GET /getCourses
```

#### Opis

Zwraca wszystkie dostepne kursy.

## getCourseGroups

Source code: [link](../restservice/src/main/java/com/plannaplan/controllers/GroupController.java)

```
GET /getCourse
```

#### Opis

Endpoint konfigurujacy caly system i importujacy dane do bazy.
